# coding: utf-8

"""
AliasesApi.py
Copyright 2016 SmartBear Software

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

from __future__ import absolute_import

import sys
import os

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class AliasesApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def create_alias_route(self, hashed_code, request, **kwargs):
        """
        Create alias
        Creates an alias.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_alias_route(hashed_code, request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str hashed_code: Unique hashed code for an alias. (required)
        :param CreateAliasRequest request:  (required)
        :param str authorization: Authorization scheme and credentials.
        :return: CreateAliasResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['hashed_code', 'request', 'authorization']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_alias_route" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'hashed_code' is set
        if ('hashed_code' not in params) or (params['hashed_code'] is None):
            raise ValueError("Missing the required parameter `hashed_code` when calling `create_alias_route`")
        # verify the required parameter 'request' is set
        if ('request' not in params) or (params['request'] is None):
            raise ValueError("Missing the required parameter `request` when calling `create_alias_route`")

        resource_path = '/aliases/{hashedCode}'.replace('{format}', 'json')
        path_params = {}
        if 'hashed_code' in params:
            path_params['hashedCode'] = params['hashed_code']

        query_params = {}

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'request' in params:
            body_params = params['request']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept([])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        response = self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreateAliasResponse',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def delete_alias_route(self, hashed_code, **kwargs):
        """
        Delete alias
        Deletes an alias.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_alias_route(hashed_code, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str hashed_code: Unique hashed code for an alias. (required)
        :param str authorization: Authorization scheme and credentials.
        :return: Function1RequestContextBoxedUnit
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['hashed_code', 'authorization']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_alias_route" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'hashed_code' is set
        if ('hashed_code' not in params) or (params['hashed_code'] is None):
            raise ValueError("Missing the required parameter `hashed_code` when calling `delete_alias_route`")

        resource_path = '/aliases/{hashedCode}'.replace('{format}', 'json')
        path_params = {}
        if 'hashed_code' in params:
            path_params['hashedCode'] = params['hashed_code']

        query_params = {}

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept([])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        response = self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Function1RequestContextBoxedUnit',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_alias_route(self, hashed_code, **kwargs):
        """
        Get alias
        Get an alias.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_alias_route(hashed_code, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str hashed_code: Unique hashed code for an alias. (required)
        :param str authorization: Authorization scheme and credentials.
        :return: GetAliasResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['hashed_code', 'authorization']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_alias_route" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'hashed_code' is set
        if ('hashed_code' not in params) or (params['hashed_code'] is None):
            raise ValueError("Missing the required parameter `hashed_code` when calling `get_alias_route`")

        resource_path = '/aliases/{hashedCode}'.replace('{format}', 'json')
        path_params = {}
        if 'hashed_code' in params:
            path_params['hashedCode'] = params['hashed_code']

        query_params = {}

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept([])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='GetAliasResponse',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response
