# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class GetTransactionResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        GetTransactionResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'timestamp': 'datetime',
            'description': 'str',
            'amount': 'Money',
            'transfer_id': 'str'
        }

        self.attribute_map = {
            'timestamp': 'timestamp',
            'description': 'description',
            'amount': 'amount',
            'transfer_id': 'transferId'
        }

        self._timestamp = None
        self._description = None
        self._amount = None
        self._transfer_id = None

    @property
    def timestamp(self):
        """
        Gets the timestamp of this GetTransactionResponse.


        :return: The timestamp of this GetTransactionResponse.
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """
        Sets the timestamp of this GetTransactionResponse.


        :param timestamp: The timestamp of this GetTransactionResponse.
        :type: datetime
        """
        self._timestamp = timestamp

    @property
    def description(self):
        """
        Gets the description of this GetTransactionResponse.


        :return: The description of this GetTransactionResponse.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this GetTransactionResponse.


        :param description: The description of this GetTransactionResponse.
        :type: str
        """
        self._description = description

    @property
    def amount(self):
        """
        Gets the amount of this GetTransactionResponse.


        :return: The amount of this GetTransactionResponse.
        :rtype: Money
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """
        Sets the amount of this GetTransactionResponse.


        :param amount: The amount of this GetTransactionResponse.
        :type: Money
        """
        self._amount = amount

    @property
    def transfer_id(self):
        """
        Gets the transfer_id of this GetTransactionResponse.


        :return: The transfer_id of this GetTransactionResponse.
        :rtype: str
        """
        return self._transfer_id

    @transfer_id.setter
    def transfer_id(self, transfer_id):
        """
        Sets the transfer_id of this GetTransactionResponse.


        :param transfer_id: The transfer_id of this GetTransactionResponse.
        :type: str
        """
        self._transfer_id = transfer_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

