# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class ProxyCreatePaymentRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ProxyCreatePaymentRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'payee_authority': 'Authority',
            'description': 'str',
            'amount': 'Money',
            'route': 'Route'
        }

        self.attribute_map = {
            'payee_authority': 'payeeAuthority',
            'description': 'description',
            'amount': 'amount',
            'route': 'route'
        }

        self._payee_authority = None
        self._description = None
        self._amount = None
        self._route = None

    @property
    def payee_authority(self):
        """
        Gets the payee_authority of this ProxyCreatePaymentRequest.


        :return: The payee_authority of this ProxyCreatePaymentRequest.
        :rtype: Authority
        """
        return self._payee_authority

    @payee_authority.setter
    def payee_authority(self, payee_authority):
        """
        Sets the payee_authority of this ProxyCreatePaymentRequest.


        :param payee_authority: The payee_authority of this ProxyCreatePaymentRequest.
        :type: Authority
        """
        self._payee_authority = payee_authority

    @property
    def description(self):
        """
        Gets the description of this ProxyCreatePaymentRequest.


        :return: The description of this ProxyCreatePaymentRequest.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this ProxyCreatePaymentRequest.


        :param description: The description of this ProxyCreatePaymentRequest.
        :type: str
        """
        self._description = description

    @property
    def amount(self):
        """
        Gets the amount of this ProxyCreatePaymentRequest.


        :return: The amount of this ProxyCreatePaymentRequest.
        :rtype: Money
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """
        Sets the amount of this ProxyCreatePaymentRequest.


        :param amount: The amount of this ProxyCreatePaymentRequest.
        :type: Money
        """
        self._amount = amount

    @property
    def route(self):
        """
        Gets the route of this ProxyCreatePaymentRequest.


        :return: The route of this ProxyCreatePaymentRequest.
        :rtype: Route
        """
        return self._route

    @route.setter
    def route(self, route):
        """
        Sets the route of this ProxyCreatePaymentRequest.


        :param route: The route of this ProxyCreatePaymentRequest.
        :type: Route
        """
        self._route = route

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

